\\ Copyright 2022 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


\\ Checks of the work-in-progress OEIS-data-wip.gp.


default(recover,0);
default(strictargs,1);

read("../OEIS-data.gp");
read("../OEIS-data-wip.gp");  \\ check multiple reads
read("../OEIS-data-wip.gp");
read("../OEIS-data-wip.gp");

option_verbose = 0;

print("HOME is:");
system("printenv HOME");

\\ Whether to print test progress and names.
if(option_verbose=='option_verbose, option_verbose=0);


\\-----------------------------------------------------------------------------
\\ Test Helpers

check_count = 0;
check_equal(got,want,name="") =
{
  check_count++;
  if(got != want,
     print("wrong "name);
     print("got  "got);
     print("want "want);     quit(1));
  if(option_verbose,
     print("ok "check_count" "name));
}


\\=============================================================================
\\-----------------------------------------------------------------------------
\\ OEIS_INTERNAL_leading_anum()

{
  check_equal(OEIS_INTERNAL_leading_anum("A123456"), "A123456");
  check_equal(OEIS_INTERNAL_leading_anum('A123456), "A123456");
  check_equal(OEIS_INTERNAL_leading_anum("A123456_blah_blah"), "A123456");

  check_equal(OEIS_INTERNAL_leading_anum("is_A123456"), "A123456",
              "is_A123456");
  check_equal(OEIS_INTERNAL_leading_anum("is_A123456_blah"), "A123456");
}


\\==============================================================================
\\ test-symbols.txt is all symbols appearing in OEIS-data.gp.

\\ {
\\   my(test_symbols=readstr("test-symbols.txt"));
\\   check_equal(#test_symbols>0,1);
\\   for(test_i=1,#test_symbols,
\\      my(test_symbol=test_symbols[test_i]);
\\      check_equal(eval(test_symbol),
\\                  eval(Str("'"test_symbol)),
\\                  Str("leftover global variable: "test_symbol)));
\\ }

\\-----------------------------------------------------------------------------
{
  check_equal(anum,anum);
  check_equal(n,'n);
  check_equal(offset,'offset);

  printf("total %d tests in %.1f seconds\n",
         check_count, gettime() /1000);
}

\\-----------------------------------------------------------------------------
\\ Local variables:
\\ compile-command: "cd .. && make test"
\\ End:
